#version 100
#extension GL_OES_EGL_image_external : require

precision mediump float;

uniform sampler2D uTexture;
uniform mediump int uShadowLayer;
uniform float intensity;
uniform vec3 shadowColor;

// video
uniform int videoEnabled;
uniform samplerExternalOES uVideoFrame;

//
varying vec2 vTexPosition;

void main() {
   vec4 color = vec4(0.0, 0.0, 0.0, 1.0);
   if (videoEnabled <= 0) {
      color = texture2D(uTexture, vTexPosition);
         if (uShadowLayer <= 0) {
            // show texture
         }
         else {
            // make shadow
            color = vec4(shadowColor, color.a * intensity);
         }

   } else {
      // video color
      color = texture2D(uVideoFrame, vTexPosition);
   }

   gl_FragColor = color;
}