precision mediump float;

uniform sampler2D uTexture;
uniform mediump int uShadowLayer;
uniform float intensity;
uniform vec3 shadowColor;

varying vec2 vTexPosition;

void main() {
   vec4 color = texture2D(uTexture, vTexPosition);
   if (gl_FrontFacing) {
      if (uShadowLayer <= 0) {
         // show texture
      }
      else {
         // make shadow
         color = vec4(shadowColor, color.a * intensity);
      }
   }
   else {
      if (uShadowLayer <= 0) {
         // make texture as dark
         color = vec4(color.rgb * 0.3, color.a);
      }
      else {
         // don't draw shadow
         discard;
      }
   }

   gl_FragColor = color;
}